<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org" xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout" xmlns:sec="http://www.thymeleaf.org/extras/spring-security" layout:decorate="~{layout2}">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Setting Template</title>
</head>
<body>
    <main layout:fragment="main" class="container-xxl bd-gutter mt-3 my-md-4  bd-layout">
        <div th:include="sidebar_setting::sidebar_setting" th:remove="tag"> sidebar </div>
        <main class="bd-main-xxl">
            <div class="row">
                <div class="col-md-12">
                    <div class="h4 pb-2 mb-4 text-dark border-bottom border-dark">
                        Setting Template Journal
                    </div>
                </div>
            </div>
            <br>
            <div class="row">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-header">
                            <h4>List</h4>
                        </div>
                        <div class="card-body">
                            <form id="searchForm" method="get">
                                <div class="row">
                                    <div class="col-md-5">
                                        <div class="form-group">
                                            <label>Departemen</label>
                                            <select name="departemen" id="selectDepartemen" class="form-control">
                                                <option value="" selected>- Pilih -</option>
                                                <option th:each="data, row:${departemen}" 
                                                    th:value="${data.id}"
                                                    th:text="${data.namaDepartemen}"></option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-md-5">
                                        <div class="form-group">
                                            <label>Period</label>
                                            <select name="periode" id="selectPeriode" class="form-control">
                                                <option value="" selected>- Pilih -</option>
                                                <option th:each="data, row:${periode}" 
                                                    th:value="${data.id}"
                                                    th:text="${data.namaPeriodeAnggaran}"></option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-md-2">
                                        <br>
                                        <button type="button" class="btn btn-outline-success" onclick="fetchData()">Cari</button>
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="card-body">
                            <div class="table-responsive">
                                <table class="table table-striped table-sm table-hover" id="dataTable">
                                  <thead class="table-dark" style="--bs-table-bg: #0a3e8a; font-size: 14px;">
                                    <tr>
                                      <th width="4%">#</th>
                                      <th width="10%">Code</th>
                                      <th width="16%">Budget name</th>
                                      <th width="20%">Work Program</th>
                                      <th width="20%">Detail Budget Description</th>
                                      <th width="15%">Pilihan</th>
                                      <th width="15%">Journal Template</th>
                                    </tr>
                                  </thead>
                                  <tbody id="dataBody">
                                  </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </main>
    </main>


</body>
</html>
<link rel="stylesheet" th:href="@{/css/sweetalert2.min.css}">
  <!-- SweetAlert2 JS -->
<script th:src="@{/js/sweetalert2.js}"></script>
<script>
    async function fetchData() {
        const departemen = document.getElementById('selectDepartemen').value;
        const periode = document.getElementById('selectPeriode').value;

        if (!departemen || !periode) {
            alert('Please select both Departemen and Period');
            return;
        }

        try {
            const response = await fetch(`/api/v1/settingtemplate/all?departemen=${departemen}&periode=${periode}`);
            const result = await response.json();

            if (response.ok) {
                displayData(result.data);
            } else {
                console.error('Error fetching data:', result);
            }
        } catch (error) {
            console.error('Error:', error);
        }
    }

    function displayData(data) {
        const tbody = document.getElementById('dataBody');
        tbody.innerHTML = '';  // Clear existing data

        data.forEach((item, index) => {
            const row = document.createElement('tr');
            row.innerHTML = `
                <td>${index + 1}</td>
                <td>${item.anggaran.kodeAnggaran}</td>
                <td>${item.anggaran.namaAnggaran}</td>
                <td>${item.programKerja || '-'}</td>
                <td>${item.deskripsi || '-'}</td>
                <td>
                    <select class="form-control pilihan-select" id="pilihan-${index}" data-id="${item.id}" name="pilihan">
                        <option selected>-- pilih --</option>
                        <option value="PENGADAAN" ${item.pilihan === 'PENGADAAN' ? 'selected' : ''}>Pengadaan</option>
                        <option value="KEGIATAN" ${item.pilihan === 'KEGIATAN' ? 'selected' : ''}>Kegiatan</option>
                    </select>
                </td>
                <td>
                    <select class="selectjournal codeTemp-select" data-id="${item.id}" style="width: 250px;" name="codeTemp">
                                <option value="" selected>-- pilih --</option>
                            </select>
                </td>
            `;
            tbody.appendChild(row);
        });

        // Pass the data to the fetchAndPopulateSelectJournal function
        fetchAndPopulateSelectJournal(data);

        // Attach event listeners for 'pilihan' and 'codeTemp' selects as before
        document.querySelectorAll('.pilihan-select').forEach(select => {
            select.addEventListener('change', async (event) => {
                const id = event.target.getAttribute('data-id');
                const pilihan = event.target.value;
                await updatePilihan(id, pilihan);
            });
        });

        document.querySelectorAll('.codeTemp-select').forEach(select => {
            $(select).on('select2:select', async function(event) {
                const id = event.target.getAttribute('data-id');
                const codeTemp = $(this).val();
                await updateCodeTemp(id, codeTemp);
            });
        });
    }

    // Modify this function to accept data as a parameter
    async function fetchAndPopulateSelectJournal(data) {
        try {
            const response = await fetch('/api/v1/settingtemplate/temp');
            const result = await response.json();

            // Generate options for select elements
            const options = result.data.map(item => {
                return `<option value="${item.code}">${item.code} - ${item.name} (${item.category})</option>`;
            }).join('');

            // Populate all .selectjournal elements with the options and initialize Select2
            document.querySelectorAll('.selectjournal').forEach(select => {
                const id = select.getAttribute('data-id');
                const itemTemplateJurnal = data.find(item => item.id == id)?.templateJurnal || null;

                // Set the options and initialize Select2
                select.innerHTML = `<option value="" selected>-- pilih --</option>` + options;
                $(select).select2({
                    theme: "bootstrap-5",
                    width: 'style',
                    placeholder: '-- pilih --'
                });

                // If item.templateJurnal matches an option, select it
                if (itemTemplateJurnal) {
                    $(select).val(itemTemplateJurnal).trigger('change');
                }
            });
        } catch (error) {
            console.error('Error fetching data:', error);
        }
    }

    // Function to update 'pilihan' in the database
    async function updatePilihan(id, pilihan) {
        try {
            const response = await fetch(`/api/v1/settingtemplate/pilihan?id=${id}&pilihan=${pilihan}`);
            if (!response.ok) {
                throw new Error('Failed to update pilihan');
            }
            const result = await response.json();
            console.log('Update pilihan response:', result);
            Swal.fire({
                position: "top-end",
                icon: "success",
                title: "Data berhasil diubah",
                showConfirmButton: false,
                timer: 1500
            });
        } catch (error) {
            console.error('Error updating pilihan:', error);
        }
    }

    // Function to update 'codeTemp' in the database
    async function updateCodeTemp(id, codeTemp) {
        try {
            const response = await fetch(`/api/v1/settingtemplate/selecttemp?id=${id}&codeTemp=${codeTemp}`);
            if (!response.ok) {
                throw new Error('Failed to update codeTemp');
            }
            const result = await response.json();
            console.log('Update codeTemp response:', result);
            Swal.fire({
                position: "top-end",
                icon: "success",
                title: "Data berhasil diubah",
                showConfirmButton: false,
                timer: 1500
            });
        } catch (error) {
            console.error('Error updating codeTemp:', error);
        }
    }




    $( '#selectDepartemen' ).select2( {
        theme: "bootstrap-5",
        width: $( this ).data( 'width' ) ? $( this ).data( 'width' ) : $( this ).hasClass( 'w-100' ) ? '100%' : 'style',
        placeholder: $( this ).data( 'placeholder' ),
    } );

    $( '#selectPeriode' ).select2( {
        theme: "bootstrap-5",
        width: $( this ).data( 'width' ) ? $( this ).data( 'width' ) : $( this ).hasClass( 'w-100' ) ? '100%' : 'style',
        placeholder: $( this ).data( 'placeholder' ),
    } );

</script>
